Subject: Re: [Pce] Question on new IRO type

From: Dhruv Dhody <[email-masked]>
Date: Tue, 24 Jun 2014 10:37:57 +0000

Hi,

Jonathan raised a question during the last IETF (refer below or at http://www.ietf.org/mail-archive/web/pce/current/msg03661.html).

Can the authors of RFC5440 or the chairs comment on it?

Regards,
Dhruv

---------------------------------------------------------------
Dhruv Dhody
System Architect,
Huawei Technologies India Pvt. Ltd.,
Banagalore
Mobile: +91-9845062422
This e-mail and its attachments contain confidential information from
HUAWEI, which is intended only for the person or entity whose address is
listed above. Any use of the information contained herein in any way
(including, but not limited to, total or partial disclosure,
reproduction, or dissemination) by persons other than the intended
recipient(s) is prohibited. If you receive this e-mail in error, please
notify the sender by phone or email immediately and delete it!

From: Pce [mailto:[email-masked]] On Behalf Of Jonathan Hardwick
Sent: 05 March 2014 19:23
To: Ramon Casellas; Dhruv Dhody
Cc: [email-masked]
Subject: Re: [Pce] Question on new IRO type

Ramon, Dhruv,

In my opinion, the existing IRO object should be treated as an ordered sequence of hops.

It is true that RFC 5440 does not make any statement at all about whether the IRO is ordered.  However, we have RFC 5521, which describes the use of the EXRS subobject as follows (section 2.2.2):

   If a PCE parses an IRO and encounters an EXRS [...] the PCE MUST NOT
   produce a path that includes any resource identified by the EXRS
   subobject in the path between the previous abstract node in the IRO
   and the next abstract node in the IRO.

Although this is open to interpretation, I think that this implies that the abstract nodes in the IRO are specified in order.

Instead of creating a new object type for “ordered IRO”, I would prefer to resolve this by clarifying that the IRO in RFC 5440 is ordered.  Your draft and the protocol will be simpler as a result.

If operators have use cases for which an unordered IRO is required, then I think this should be dealt with by creating a new object type for “unordered IRO” (and probably excluding the use of EXRS in that object).  But that would not need to be dealt with by your draft.

Of course, this is just my opinion, and is still open to interpretation as we have said.

Best regards
Jon

From: Ramon Casellas [mailto:[email-masked]]
Sent: 04 March 2014 09:36
To: [email-masked]<mailto:[email-masked]>; Jonathan Hardwick
Subject: Re: [Pce] Question on new IRO type

On 03/04/2014 10:32 AM, Ramon Casellas wrote:

All,

As elaborated in [1] (see option c)
Err, I meant b).  The motivations were mainly:

  1. _Object Ordering_
    2. _Different Scopes_
    3. _Limited Procedures_
    4.  _Strict vs Loose_

R.

---

From: "Adrian Farrel" <[email-masked]>
Date: Tue, 24 Jun 2014 12:21:59 +0100

Dhruv,
 
I'm named as a Contributor on 5440. Speaking purely for myself, I had not considered the issue of "set" versus "ordered list" when this object was defined.
 
But I am also a co-author of 5521, and it is clear that when this was approved by the WG everyone was working on the assumption that the IRO was an ordered list.
 
I must say, however, that practically there is some confusion here.
1. An EXRS in an ordered list IRO seems to be over the top. Are we really suggesting that we are happy for node Y to be on the path, but just not between nodes X and Z? That is crazy talk! So one would use the XRO to indicate that Y should simply be excluded from the whole path.
2. But there may be some value in restricting the use of a specific interface or resource between two nodes. For example, don't use LambdaY between nodes X and Z. In this case, the language in 5521 could be modified such that the presence of an EXRS in an IRO means that the things indicated in the EXRS MUST NOT appear in the path between the resource identified by the previous IRO subobject and the next hop in the computed path.
3. If the IRO is an ordered list, doesn't the strict/loose flag suddenly become important again?
 
My personal preference would be to do the work in the WG to find out how people have implemented IRO and what the implications would be for clarifying the definition. Then either do a short I-D updating 5440, or consider whether it is time to reopen the whole RFC for updates, clarifications, and simplifications.
 
Adrian

From: Pce [mailto:[email-masked]] On Behalf Of Dhruv Dhody
Sent: 24 June 2014 11:38
To: [email-masked]
Subject: Re: [Pce] Question on new IRO type
 
Hi, 

 
Regards,
Dhruv

 
Ramon, Dhruv,

 

 

Best regards
Jon

From: Ramon Casellas [mailto:[email-masked]] 
Sent: 04 March 2014 09:36
To: [email-masked]; Jonathan Hardwick
Subject: Re: [Pce] Question on new IRO type

All,

  1. _Object Ordering_
    2. _Different Scopes_
    3. _Limited Procedures_
    4.  _Strict vs Loose_

R.

---

From: Jonathan Hardwick <[email-masked]>
Date: Tue, 24 Jun 2014 15:05:25 +0000

Adrian, Dhruv, I agree with the idea of doing a survey.  A few other comments interleaved below as [JEH] ... [/JEH].

From: Pce [mailto:[email-masked]] On Behalf Of Adrian Farrel
Sent: 24 June 2014 12:22
To: 'Dhruv Dhody'; [email-masked]
Subject: Re: [Pce] Question on new IRO type

Dhruv,

[JEH] I am unsure exactly which problem(s) the EXRS is trying to solve.  But it sounds as though you agree that its presence implies an ordering on the IRO. [/JEH]

[JEH] If X and Z are not adjacent in the computed path then this does not preclude LambdaY from being used somewhere between X and Z. [/JEH]

[JEH] Yes, I agree, it does. [/JEH]

Adrian

From: Pce [mailto:[email-masked]] On Behalf Of Dhruv Dhody
Sent: 24 June 2014 11:38
To: [email-masked]<mailto:[email-masked]>
Subject: Re: [Pce] Question on new IRO type

Hi,

Regards,
Dhruv

Cc: [email-masked]<mailto:[email-masked]>

Ramon, Dhruv,

Best regards
Jon

All,

  1. _Object Ordering_
    2. _Different Scopes_
    3. _Limited Procedures_
    4.  _Strict vs Loose_

R.